<html>
	<head>
		<title>Projet Groupe 36</title>
				<link rel="stylesheet" href="style.css" >

	</head>
	<body>
		<h1 style="text-align: center;">Voyageur de Commerce<br></h1>
		<a href="index.html">Retourner a la page principale<br></a>
		<p></p>
	
		<center><img src="../Yvan/screenVoyageur.png" alt="Voyageur de commerce" width="700" height="400"  /></center>
		
		<U><h3>Un peu de code:<br></h3></U>
		<pre><code class="language-c">


			typedef struct sdlMedia{
				SDL_Window *window;
				SDL_Renderer *renderer;
				TTF_Font *font;
				int nString;
				SDL_Texture **stringListe;
				SDL_Rect *stringPos;
				int nSommet;
				SDL_Texture **labelListe;
				SDL_Rect *labelPos;
			} sdlMedia_t;

			typedef struct sommet{
				int x, y;
				int visite;
			} sommet_t;

			typedef struct usrSommet{
				int sommetId;
				struct usrSommet *fils;
			} usrSommet_t;

			void drawLine(sdlMedia_t *media, int xSrc, int ySrc, int xDst, int yDst){
				SDL_RenderDrawLine(media->renderer, xSrc, ySrc, xDst, yDst);
			}



		</code></pre>	
		<U><h3>Graphiquement:<br></h3></U>
		
		<center><img src="../Yvan/gif/voyageur.gif" alt="Voyageur de commerce" width="1300" height="700"  /></center>
		<p>Nous allons maintenant tenter de trouver un chemin optimal avec des méthodes d'optimisation, avec le graphe précédent, nous avons obtenu les scores suivant (distances en pixels) :<br><br>
		 Chemin Utilisateur : 3045
<br>
Methode gloutonne : 3553
<br>
Méthode recuit simulé : 3720
<br>
Méthode gloutonne-recuit combiné :  3553
<br><br><br></p>
		
		<U><h3>Optimisation - Méthode exhaustive:<br></h3></U>
		<U><h3>Méthode du recuit simulé:<br></h4></U>
		<h4>Etape 1 : Plus court chemin avec l'algorithme de Dijkstra</h4>
		<U><h3>Un peu de code:<br></h3></U>
		<pre><code class="language-c">

		<U><h3>Optimisation - Méthode constructive:<br></h3></U>

<p style="font-size: 18px;"></p>-Méthode des fourmies première version :<br></p>
<p style="font-size: 14px;"> Fonctions associées :<br></p>
		<pre><code class="language-c">
	void algo_fourmies(int taille, int **matriceConnexion, int **matriceProba, int *parcours_fourmie1);

	void ajout_pheromones(int** matriceProba, int *parcours_fourmie, int pheromones_ajoute, int taille);

	void algo_parcours_d_une_fourmie(int taille, int **matriceConnexion, int **matriceProba, int *tab_des_sommets_parcourru);

	int donne_le_sommet_suiv_aleat(int nb_aleat, int *list_voisin_poids, int taille);
			
	</code></pre>
<p style="font-size: 18px;"></p>-Méthode des fourmies deuxième version :<br></p>
<p style="font-size: 14px;"> Fonctions associées :<br></p>
		<pre><code class="language-c">
	void main_fourmie(int **matrice, int **matriceProba, int* listSommetDiff, int taille, int sommetDep, int *list_plus_court_chemin);

	void modif_mat_prob(int **matriceProba, int sommet, int sommet_suiv, int taille);

	int choix_chemin(int taille, int *listSommetDiff);

	Les fonctions de Corentin qui m'ont été utiles:

	int **  Matrice_complete(int ** MATRICE, int N_sommet);

	void Plus_court_chemin(int ** MATRICE, int N_sommet, int A, int B, chemin_t * chemin_le_plus_cours, int * code_err);
<center><img src="methode_fourmie_matrice_5.png" alt="Méthode des fourmies"></center>

	</code></pre>

			typedef struct chemin {
				int nb_sommet;
				int distance;
				int * suite;
			} chemin_t;
			
			chemin_t initialisation_chemin(int taille);
			
			void copier_chemin(chemin_t* source, chemin_t* dest);
			
			void Ajouter_sommet(int A, int num_chemin, chemin_t * ch, int ** MATRICE);
			
			void creer_chemin_par_voisin(int ** MATRICE, chemin_t * liste_chemin, chemin_t * chemin_suivant, int num_chemin, int taille, int * nb_chemin);
			
			void liberer_chemin(chemin_t * ch, int taille);
			
			void Plus_court_chemin(int ** MATRICE, int N_sommet, int A, int B, chemin_t * chemin_le_plus_cours, int * code_err);
			
			void afficher_chemin(chemin_t PCC);
			
			int **  Matrice_complete(int ** MATRICE, int N_sommet);


		</code></pre>	
		<center><img src="../dijkstra.svg" alt="Dijkstra" width="500" height="500"  /></center>

		<h4>Etape 2 : méthode du recuit simulé</h4>
		<U><h3>Un peu de code:<br></h3></U>
		<pre><code class="language-c">


			//Optimisation avec méthode
			void recuit_simule(int ** MATRICE, int taille, int depart, chemin_t * chemin_final)
			{
				int max_ite = 10000000;
				float p = 0.1;

				int chemin_courant[taille +1];

				randomizer(taille, chemin_courant,depart);
				
				int ** matrice_complete = Matrice_complete(MATRICE,taille);

				int distance_min = 1000000;

				for(int i = 0;i< max_ite;i++)
				{
					int d = distance_from_chemin(chemin_courant, taille, matrice_complete);
				

					if (d < distance_min || rand() < p)
					{
						chemin_final ->distance = d;
						for(int j = 0;j< taille+1;j++)
						{
							chemin_final->suite[j] = chemin_courant[j];
						}
					}

					minor_swap(chemin_courant, taille);
					p = p*0.995;
					//printf("proba = %f\n",p);
				}

				chemin_final->nb_sommet = taille+1;

				LibererMatrice(matrice_complete, taille);
			}

		</code></pre>	
	
		

		<U><h3>Optimisation - Méthode constructive:<br></h3></U>
		<U><h3>Méthode gloutonne:<br></h3></U>
			<U><h3>Un peu de code:<br></h3></U>
			<pre><code class="language-c">
	
			void methode_gloutonne(int ** MATRICE, int taille, int depart, chemin_t * chemin_final)
			{
				int ** matrice_complete = Matrice_complete(MATRICE,taille);

				int nb_sommet_cumule = 1;
				int dist = 0;
				int limit = taille * 5;

				Chemin_avec_meilleur_voisin(matrice_complete, taille, chemin_final->suite, &nb_sommet_cumule, &dist, depart, limit);

				chemin_final->distance = dist;
				chemin_final->nb_sommet = taille +1;
				chemin_final->suite[taille] = depart;
				LibererMatrice(matrice_complete, taille);
			}

			int Meilleur_voisin(int A, int N_sommet, int ** MATRICE, int * deja_visite, int nb_deja_vu);

			void liste_voisin_explicite(int A, int N_sommet, int ** MATRICE, int * vois_explicite, int * nb_vois);

			int Recherche_sommet(int A, int * list, int taille);

			int Chemin_avec_meilleur_voisin(int ** MATRICE, int N_sommet, int * chemin_final, int * nb_sommet_cumule,
										int * distance_cumule, int point_depart, int limit_ite);

	
	
			</code></pre>	

			<h3>Autre: Méthode recuit sur Méthode gloutonne<br></h3>

			<h3></p>-Méthode des fourmies première version :<br></h3>
			<p style="font-size: 14px;"> Fonctions associées :<br></p>
			<pre><code class="language-c">
			void algo_fourmies(int taille, int **matriceConnexion, int **matriceProba, int *parcours_fourmie1);

			void ajout_pheromones(int** matriceProba, int *parcours_fourmie, int pheromones_ajoute, int taille);

			void algo_parcours_d_une_fourmie(int taille, int **matriceConnexion, int **matriceProba, int *tab_des_sommets_parcourru);

			int donne_le_sommet_suiv_aleat(int nb_aleat, int *list_voisin_poids, int taille);
			
			</code></pre>
			<h3></p>-Méthode des fourmies deuxième version :<br></h3>
			<p style="font-size: 14px;"> Fonctions associées :<br></p>
			<pre><code class="language-c">
			void main_fourmie(int **matrice, int **matriceProba, int* listSommetDiff, int taille, int sommetDep, int *list_plus_court_chemin);

			void modif_mat_prob(int **matriceProba, int sommet, int sommet_suiv, int taille);

			int choix_chemin(int taille, int *listSommetDiff);

			Les fonctions de Corentin qui m'ont été utiles:

			int ** Matrice_complete(int ** MATRICE, int N_sommet);

			void Plus_court_chemin(int ** MATRICE, int N_sommet, int A, int B, chemin_t * chemin_le_plus_cours, int * code_err);
			<center><img src="methode_fourmie_matrice_5.png" alt="Méthode des fourmies"></center>

			</code></pre>


			<a href="index.html">Retourner a la page principale<br></a>
	</body>
</html>
<pre><code class="language-c">
			
</code></pre>
